"{ Package: 'jv:calipel/s/benchmarks/stx' }"

BenchmarkCollection subclass:#BenchmarkDictionaryLike
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Benchmarks-St/X'
!


!BenchmarkDictionaryLike methodsFor:'benchmarks'!

benchmarkOrderedAscAddIndividually
    <benchmark: 'Insert ordered (asc) data individually'>

    collection := collectionClass new.
    1 to: collectionDatasetSize do:[:each | collection at:each put: each printString]

    "Created: / 09-03-2014 / 10:20:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkOrderedAscRemoveIndividually
    <benchmark: 'Remove ordered (asc) data individually'>
    <setup: #(#setUpCollectionDataset1 #setUpCollectionDataset1OrderedAsc)>

    collectionDataset1OrderedAsc do:[:each | collection removeKey:each]

    "Created: / 09-03-2014 / 10:32:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2014 / 10:34:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkOrderedDescAddIndividually
    <benchmark: 'Insert ordered (desc) data individually'>

    collection := collectionClass new.
    collectionDatasetSize downTo: 1 do:[:each | collection at:each put: each printString]

    "Created: / 09-03-2014 / 10:21:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkOrderedDescRemoveIndividually
    <benchmark: 'Remove ordered (desc) data individually'>
    <setup: #(#setUpCollectionDataset1 #setUpCollectionDataset1OrderedDesc)>

    collectionDataset1OrderedDesc do:[:each | collection removeKey:each]

    "Created: / 09-03-2014 / 10:32:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-03-2014 / 23:45:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkRandomAccess
    <benchmark: 'Access random data'>
    <setup: #(#setUpCollectionDataset1)>

    collectionDataset1 do:[:each | collection at:each ]

    "Created: / 11-03-2014 / 23:06:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 24-09-2014 / 20:28:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkRandomAddIndividually
    <benchmark: 'Insert random data individually'>

    collection := collectionClass new.
    collectionDataset1 do:[:each | collection at:each put: each printString]

    "Created: / 09-03-2014 / 10:17:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkRandomRemoveIndividually
    <benchmark: 'Remove random data individually'>
    <setup: #setUpCollectionDataset1>

    collectionDataset1 do:[:each | collection removeKey:each]

    "Created: / 09-03-2014 / 10:30:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-03-2014 / 23:44:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkDictionaryLike methodsFor:'parameters'!

collectionClassName:aSymbol
    <parameter: 'Collection class name to benchmark' type: #Symbol values: #(Dictionary IdentityDictionary BTree)>

    super collectionClassName:aSymbol

    "Created: / 09-03-2014 / 10:42:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 11-03-2014 / 23:03:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkDictionaryLike methodsFor:'running'!

setUpCollectionDataset1
    collection := collectionClass new.
    collectionDataset1 do:[:each | collection at: each put: each printString ]

    "Created: / 09-03-2014 / 22:26:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkDictionaryLike class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

