class Settings::LanguagesController < SettingsController

  def index
    @language = Language.new
  end

  def show
    @language = Language.find(params[:id])
  end

  def create
    @language = Language.new(language_params) 

    if @language.save
      flash[:success] = "Language #{@language.name} successfully created"
      redirect_to action: :index
    else
      flash.now[:failure] = "There were some errors" 
      render "index"
    end
  end

  def update
    if @language.update_attributes(language_params)
      flash[:success] = "Language #{@language.name} successfully updated"
      redirect_to action: :index
    else
      flash.now[:failure] = "There were some errors" 
      render "show"
    end
  end

  def destroy
    @language = Language.find(params[:id])

    if @language.destroy
      flash[:success] = "Language #{@language.name} successfully deleted"
    else
      flash[:error] = "Could not delete #{@language.name} language"
    end

    redirect_to action: :index
  end

  private

  def language_params
    params.require(:language).permit(:name)
  end

end
